/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
var gui = require('nw.gui');
var appLayout; // a var is required because this page utilizes: myLayout.allowOverflow() method
var editors;
var appData = Object();
appData.configuration = Object();
appData.configuration.maxNumberOfRowsCosole = 1000;
appData.configuration.maxNumberOfOpenedTabs = 10;
appData.openedTabFile = [];
appData.tagElements = [];
appData.tagElementsCounter = [];
appData.selectedProjectFilter = []
appData.tagSupportContainer = {};
appData.tagSupportContainer['exe'] = {
    main: "examplesContaiener",
    tags: "examplesTagContainer"
}
appData.tagSupportContainer['pro'] = {
    main: "projectsContaiener",
    tags: "projectsTagContainer"
}
appData.openedProjectsList = []
appData.status = {
    logged: null,
    user: null,
    email: null,
    password: null
}
$(document).ready(function() {
    //appData.configuration.autoSaveInterval = setInterval(function() {
    appData.configuration.autoSaveInterval = setInterval(function() {
        Projects.saveCurrent(true)
    }, 30000)
    $.notify.addStyle('viperinfo', {
        html: '<div><span class="fa fa-info-circle notify-icon"/><span data-notify-text/></div>'
    });
    $.notify.addStyle('vipererror', {
        html: '<div><span class="fa fa-exclamation-circle  notify-icon"></span><span data-notify-text/></div>'
    });
    $.notify.addStyle('viperwarning', {
        html: '<div><span class="fa fa-warning  notify-icon"></span><span data-notify-text/></div>'
    });
    $(window).unload(function() {
        return "Are you sure you want to exit?"
    });

    gui.Window.get().maximize();
    gui.Window.get().show();
    gui.Window.get().focus();
    //mac copy & paste patch
    if (process.platform === "darwin") {
        var mb = new gui.Menu({type: 'menubar'});
        mb.createMacBuiltin('Viper', {
                hideEdit: false,
        });
        gui.Window.get().menu = mb;
    }

});
var dialogMode = {
    createNewFile: 0,
    renameNewFile: 1,
}

function start_tutorial(name) {
    if ((appData.status.user && !appData.status.logged) || ViperConf.firsttime) {
        setTimeout(function() {
            //retry until logged
            start_tutorial(name)
        }, 5000)
        return
    }
    if (!appData.status.user) {
        name = name + "-anon"
    } else {
        if (appData.status.logged) {
            name = name + "-logged"
        } else {
            return
        }
    }
    if (ViperConf.tutorials[name]) return;
    if (tutorial_list.length == 0) {
        console.log("Exec tut " + name)
        exec_tutorial(name)
    } else {
        console.log("Pushing tut " + name)
        push_tutorial(name)
    }
}
var viperApp = angular.module('viperApp', ['ui.bootstrap']);
viperApp.controller('leftMenu', function() {
    angular.element(document).ready(function($scope) {
        initAppLayout();
        editors = initCodeMirrorEditors();
        IDE.initTheme(ViperConf.theme);
        $('#listOfTags').tagsinput({
            confirmKeys: [13, 44],
            maxTags: 5
        });
        $('#listOfTagsLib').tagsinput({
            confirmKeys: [13, 44],
            maxTags: 5
        });
        $('#listOfKeywordsLib').tagsinput({
            confirmKeys: [13, 44],
            maxTags: 3
        });

        $('#listOfTagsLib').tagsinput({
            confirmKeys: [13, 44],
            maxTags: 5
        });
        $('#listOfTagsFork').tagsinput({
            confirmKeys: [13, 44],
            maxTags: 5
        });
        var to = false;
        $('#plugins4_tagtree').keyup(function() {
            if (to) {
                clearTimeout(to);
            }
            to = setTimeout(function() {
                var v = $('#plugins4_tagtree').val();
                $('#tagtree').jstree(true).search(v);
            }, 250);
        });
        var toe = false;
        $('#plugins4_extree').keyup(function() {
            if (toe) {
                clearTimeout(toe);
            }
            toe = setTimeout(function() {
                var v = $('#plugins4_extree').val();
                $('#examplesContaiener').jstree(true).search(v);
            }, 250);
        });
        var tov = false;
        $('#plugins4_vpmtree').keyup(function(e) {
            if (e.which==13){
                var v = $('#plugins4_vpmtree').val();
                Vpm.search(v);
            }
        });
        $('#vpmcontrolzone input[type="checkbox"]').change(function () {
            Vpm.filter()
        });
        $scope.isActive = true;
        //$('#viewToggler').change(function() {Projects.switch_view()})
        $('#deviceSelect').change(function() {
            Devices.selectDevice(this.value);
        })
        var toc = false;
        $('#plugins4_console').keypress(function(ev) {
            var send_char = $("#console_mode").is(":checked")
            if (send_char) {
                if (ev.keyCode == 13) Devices.send("\n")
                else Devices.send(String.fromCharCode(ev.charCode))
                var me = this
                me.value = String.fromCharCode(ev.charCode)
                if (toe) {
                    clearTimeout(toe);
                } else toc = setTimeout(function() {
                    me.value = ""
                }, 300)
                return false
            } else {
                if (ev.keyCode == 13) {
                    //send val
                    Devices.send(this.value + "\n")
                    this.value = ""
                }
                return true
            }
        })
        editors.code.setSize($('#centerDiv > .ui-layout-pane-center').width(), $('#centerDiv > .ui-layout-pane-center').height() - $(".codeEditorToolbar").height())
            //$('[data-toggle="tooltip"]').tooltip({placement: "bottom"})
        $('.tooltip-br').qtip({
            position: {
                my: 'top left',
                at: 'bottom right'
            }
        });
        $('.tooltip-bl').qtip({
            position: {
                my: 'top right',
                at: 'bottom left'
            }
        });
        $('.tooltip-tl').qtip({
            position: {
                my: 'top left',
                at: 'top left'
            }
        });
        $('#splashscreen').hide();
        if (ViperConf.firsttime) {
            tour.init();
            tour.start();
        } else {
            setTimeout(function() {
                if (appData.projects && appData.projects.length <= 0) {
                    start_tutorial("new-project")
                }
            }, 5000)
        }
        if ((Math.floor(Date.now() / 1000) - ViperConf.tutorials["reminder-anon"]) > 60 * 60 * 24 * 7 && !appData.status.user) {
            setTimeout(function() {
                ViperConf.tutorials["reminder-anon"] = (Math.floor(Date.now() / 1000))
                setTimeout(function() {
                    ViperIDEClient.send_conf()
                }, 5000)
                if (!appData.status.user) {
                    $("#buttonLogin").qtip({
                        position: {
                            my: 'top right',
                            at: 'bottom left'
                        },
                        content: {
                            title: "Create a User!",
                            text: "Remeber that by creating a user you can keep your projects safe on the cloud! You can also get instant notifications about updates. Click here to signup!",
                            button: true
                        },
                        hide: {
                            event: false
                        },
                        show: {
                            ready: true,
                            event: null
                        }
                    })
                }
            }, 5000)
        }
        if (ViperConf.type == "testing") {
            $.notify("Test Version " + ViperConf.version + " build "+ViperConf.build, {
                position: 'bottom left',
                clickToHide: false,
                autoHide: false
            });
        }
        initViperServer(editors);
        Vpm.init()
    });
});
viperApp.controller('logController', function() {})

function initAppLayout() {
    appLayout = $('body').layout({
        enableCursorHotkey: false,
        north: {
            resizable: false,
            spacing_open: 0,
            minSize: 48,
            size: 48
        },
        east: {
            initClosed: true,
            size: 300,
            resizable: true
        },
        west: {
            size: 300,
            minSize: 240,
            resizable: true
        },
        onresize_end: function(name, el, state, opts, lname) {
            if (name == "east") {
                console.log(state.innerWidth, state.innerHeight)
                editors.console.setSize(state.innerWidth, state.innerHeight - $(".deviceConsoleToolbar").height() - 36)
            }
        },
        onshow_end: function(name, el, state, opts, lname) {
            console.log("SHOW!")
            onresize_end(name, el.state.opts, lname)
        },
        onopen_end: function(name, el, state, opts, lname) {
            onresize_end(name, el.state.opts, lname)
        }
    });
    appLayout2 = $('#centerDiv').layout({
        enableCursorHotkey: false,
        onresize_end: function(name, el, state, opts, lname) {
            if (name == "center") {
                editors.code.setSize(state.innerWidth, state.innerHeight - $(".codeEditorToolbar").height())
            } else if (name == "south") {
                editors.logger.setSize(state.innerWidth, state.innerHeight)
            }
        },
        onshow_end: function(name, el, state, opts, lname) {
            onresize_end(name, el.state.opts, lname)
        },
        onopen_end: function(name, el, state, opts, lname) {
            onresize_end(name, el.state.opts, lname)
        },
        south: {
            initClosed: false,
            resizable: true,
            size: 120,
            minSize: 80,
            maxSize: 240
        }
    });
    Tags.resizeTagElemet();
}

function initCodeMirrorEditors() {
    var logEditor = CodeMirror(document.getElementById("logger"), {
        value: "",
        lineNumbers: false,
        readOnly: false,
        theme: "viper-dark",
        //theme: "neat",
        mode: "null",
        viewportMargin: Infinity
    });
    var editor = CodeMirror(document.getElementById("code_editor"), {
        value: "",
        mode: {
            name: "python",
            version: 3,
            singleLineStringErrors: false
        },
        lineNumbers: true,
        smartIndent: true,
        matchBrackets: true,
        tabSize: 4,
        indentUnit: 4,
        indentWithTabs: false,
        theme: "viper-dark",
        readOnly: true,
        keyMap: "sublime",
        extraKeys: {
            "Ctrl-S": function(instance) {
                Projects.saveCurrent(true)
            },
            "Cmd-S": function(instance) {
                Projects.saveCurrent(true)
            },
            "Ctrl-Q": "toggleComment",
            "Ctrl-Space": "autocomplete",
            "Tab": function(cm) {
                var spaces = Array(cm.getOption("indentUnit") + 1).join(" ");
                cm.replaceSelection(spaces);
            },
            "Alt-Up": "indentMore",
            "Alt-Down": "indentLess",
            "F11": function() {
                    gui.Window.get().toggleFullscreen();
            }
        },
        foldGutter: true,
        gutters: ["CodeMirror-linenumbers", "CodeMirror-foldgutter", "py-marker"],
        highlightSelectionMatches: true,
        styleActiveLine: true,
        fixedGutter: true,
        showTrailingSpace: true,
        //scrollbarStyle: "simple"
    });
    editor.on("change", function() {
        ViperIDEClient.saved = false;
        //CodeEditor.clearErrors()
    })
    var tow = false
    editor.on("keypress", function(cm, event) {
        var c = String.fromCharCode(event.which)
        if (!(editors.code.getOption("readOnly") === false)) {
            if (!tow) {
                IDE.alert("Document is locked!", "viperwarning")
                tow = setTimeout(function() {
                    tow = false
                }, 1000);
            }
        } else if (!editor.state.completionActive && ((c >= '0' && c <= '9') || (c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z'))) {
            editor.showHint({
                hint: function(ed, opt) {
                    var a;
                    var b = CodeMirror.hint.python(ed, opt)
                    if (b.no_more){
                        a={from:false,to:false,list:[]}
                    } else {
                        a= CodeMirror.hint.anyword(ed, opt)
                    }
                    var res = {
                        from: (a.from) ? a.from : b.from,
                        to: (a.to) ? a.to : b.to,
                        list: a.list.concat(b.list).filter(function(el, i, a) {
                            if (i == a.indexOf(el)) return 1;
                            return 0
                        })
                    }
                    res.list.sort()
                    return res
                }
            });
        }
        return false
    })
    var mon = CodeMirror(document.getElementById("device_console"), {
        value: "",
        lineNumbers: false,
        readOnly: true,
        mode: "null",
        gutters: ["py-excs"],
        fixedGutter: false
    });
    /*mon.on("dblclick", function(cm, event) {
        var doc = cm.getDoc()
        if (doc) {
            var line = cm.lineInfo(doc.getCursor().line).text
            var res = /@\[([0-9A-F]{4}(?::[0-9A-F]{4})+)\]/g;
            var match = res.exec(line)
            if (match && match.length >= 1) {
                Project.debug(match[1])
                $("#debugException").tab("show")
                Project.debug_exception_ui()
                return false
            }
        }
        return true
    })*/
    var excode = CodeMirror.fromTextArea(document.getElementById("exampleCode"), {
        value: "",
        lineNumbers: true,
        readOnly: true,
        mode: {
            name: "python",
            version: 3,
            singleLineStringErrors: false
        },
    });
    var exdesc = CodeMirror.fromTextArea(document.getElementById("exampleDesc"), {
        value: "",
        lineNumbers: false,
        lineWrapping: true,
        readOnly: true,
        mode: "null"
    });
    //excode.setSize("95%","400px")
    //exdesc.setSize("95%","200px")
    var editors = {
        log: logEditor,
        code: editor,
        console: mon,
        excode: excode,
        exdesc: exdesc
    }
    editor.setValue("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"); //prevent strange behaviour in codemirror gutters...(todo: investigate)
    return editors;
}

function initViperServer() {
    try {
        ViperIDEClient.init();
    } catch (e) {
        //writeToLogEditor("Error connectiong to Viper server!\n")
    }

    function onOpen() {
        //writeToLogEditor("Connection Opened!\n")
    }

    function onClose() {
        if(IDE.restarting){
            $('<div class="modal-backdrop"></div>').appendTo(document.body);
            IDE.alert("The IDE is going to restart...", "viperinfo")
            setTimeout(function(){gui.Window.get().close()},2000)
        } else if (!IDE.reload_attempts) {
            $('<div class="modal-backdrop"></div>').appendTo(document.body);
            IDE.alert("The SERVER is not responding!! Please restart the  IDE", "vipererror")
            setTimeout(function(){gui.Window.get().close()},5000)
        } else {
            IDE.alert("The IDE is going to start!", "viperinfo")
            setTimeout(function(){gui.Window.get().close()},2000)
        }
    }

    function onError(msg) {
        // bootbox.alert("Server not found!")
        $('<div class="modal-backdrop"></div>').appendTo(document.body);
        IDE.alert("The SERVER is not responding!! Please restart the  IDE", "vipererror")
        setTimeout(function(){gui.Window.get().close()},5000)
    }

    function onPing(msg) {
        //writeToLogEditor("ping: " + JSON.stringify(msg) + "\n")
        ViperIDEClient.answer(msg)
    }

    function onExamples(msg) {
        appData.extree = msg.data[0];
        appData.exlist = msg.data[1];
        appData.exord = msg.data[2];
        Examples.init();
        //Tags.createTagsElements(appData.examples, 'exe');
        //Tags.filterProjects('exe');
    }

    function onProject(msg) {
        appData.currentProject = msg.data;
        appData.currentProject.compile_info = {}
        appData.currentProject.lint_info = {}
        //$("#selectedProjectName").text(appData.currentProject.name)
        for (var i = 0; i < appData.projects.length; i++) {
            if (appData.projects[i].id == appData.currentProject.id) {
                appData.projects[i].files = appData.currentProject.files;
                break
            }
        }
        Project.init()
        CodeEditor.drawTabs()
        $("#fileTabElement a").click();
        ViperIDEClient.saved = true
        $('#compileButton').prop('disabled', false);

        if ('namespace' in appData.currentProject) {
            updateToggleTestingReleaseButton();
            $('#publishLib').prev().show();
            // var showPubIfConn = function() {
            if (appData.status.logged) {
                $('#publishLib').show();
            }
            else {
                $('#publishLib').hide();
            }
            // };
            // setTimeout(showPubIfConn, 2000);
            // showPubIfConn();
            $('#toggleTestingRelease').show();
            $('#compileDocs').show();
            $('#viewDocs').hide();
            var files = Object.keys(appData.currentProject.files);
            for (var i=0; i < files.length; i++) {
                if (files[i].match("^docs/html")) {
                    $('#viewDocs').show();
                    break;
                }
            }
        }
        else {
            $('#publishLib').prev().hide();
            $('#publishLib').hide();
            $('#toggleTestingRelease').hide();
            $('#compileDocs').hide();
            $('#viewDocs').hide();
        }

        if (!appData.projects || appData.projects.length <= 1) {
            setTimeout(function() {
                start_tutorial("first-project")
            }, 3000)
        }
    }

    function onProjects(msg) {
        appData.projects = msg.data;
        Projects.init();
        //Tags.createTagsElements(appData.projects, 'pro');
        //Tags.filterProjects('pro');
        if (!appData.currentProject) {
            $('#compileButton').prop('disabled', true);
            //$('#tabProjects').click();
        } else {
            $('#compileButton').prop('disabled', false);
        }
        if (appData.projects && appData.projects.length == 3) {
            start_tutorial("browse-project")
        }
    }

    function onDevices(msg) {
        Devices.devices = {}
        var allvirtual=true;
        for (var i = 0; i < msg.data.length; i++) {
            Devices.devices[msg.data[i].device] = msg.data[i]
            allvirtual = allvirtual && msg.data[i].virtual
        }
        Devices.init()
        if (!allvirtual) {
            start_tutorial("board-plugged")
                //writeToEditor(JSON.stringify(msg), "devices")
        }
    }

    function onConsoleMsg(msg) {
        Devices.storeMessage(msg)
    }

    function onCloseConsole(msg) {
        Devices.closeTabFromServer(msg.data.console_id)
    }

    function onStatusMsg(msg) {
        appData.status = msg.data;

        if (appData.status.logged && appData.currentProject) {
            if ('namespace' in appData.currentProject) {
                $("#publishLib").show();
            }
            else {
                $("#publishLib").hide();
            }
        }        
        IDE.init()
    }

    function onVms(msg) {
        appData.vms = msg.data
            //writeToEditor(JSON.stringify(msg), "vms")
    }

    function onMessage(msg) {
        writeToLogEditor(msg.data);
    }

    function dumpMsg(msg) {
        writeToEditor("msg: " + JSON.stringify(msg) + "\n", "log")
    }

    function onDialog(msg) {
        if (msg.data.msg) {
            IDE.dialog(msg.data.title, msg.data.msg, true);
        } else bootbox.hideAll()
    }

    function onNotify(msg) {
        $.notify(msg.data.msg, {
            style: msg.data.style,
            position: msg.data.position
        });
    }

    function onUpdateStats(msg){
        IDE.handle_update(msg)
    }

    function onVpmStatus(msg){
        Vpm.updateStatus(msg.data.index)
    }

    function onFeed(msg){
        IDE.show_feed(msg)
    }

    ViperIDEClient.on("open", onOpen);
    ViperIDEClient.on("close", onClose);
    ViperIDEClient.on("error", onError);
    ViperIDEClient.on("ping", onPing);
    ViperIDEClient.on("project", onProject);
    ViperIDEClient.on("projects", onProjects);
    ViperIDEClient.on("devices", onDevices);
    ViperIDEClient.on("examples", onExamples);
    ViperIDEClient.on("console_msg", onConsoleMsg);
    ViperIDEClient.on("console_close", onCloseConsole);
    ViperIDEClient.on("status", onStatusMsg);
    ViperIDEClient.on("vms", onVms);
    ViperIDEClient.on("msg", onMessage);
    ViperIDEClient.on("dialog", onDialog);
    ViperIDEClient.on("notify", onNotify);
    ViperIDEClient.on("quit", window.close);
    ViperIDEClient.on("update_stats", onUpdateStats);
    ViperIDEClient.on("vpm_status", onVpmStatus);
    ViperIDEClient.on("feed", onFeed);
    ViperIDEClient.on("_", dumpMsg);
    try {
        ViperIDEClient.start();
    } catch (e) {
        //writeToLogEditor("Error connectiong to Viper server!\n")
    }
    return appData;
}

function writeToLogEditor(text) {
    editors.log.replaceRange(text + '\n', CodeMirror.Pos(editors.log.lastLine()));
    if (editors.log.lastLine() > appData.configuration.maxNumberOfRowsCosole) {
        editors.log.replaceRange("", CodeMirror.Pos(editors.log.firstLine() - 1), CodeMirror.Pos(editors.log.firstLine() + 1));
    }
    var h = editors.log.getScrollInfo().height;
    editors.log.scrollTo(0, h);
}

function initExamplesMenu() {
    var container = $("#examplesContaiener");
    container.empty();
    for (var i = 0; i < appData.examples.length; i++) {
        var example = appData.examples[i];
        var htmlElementStr = '<li class="list-group-item">' + '<a class="progectNameLink" onclick="Projects.forkFromExample(\'' + example.name + '\')">' + example.name + "</a></li>";
        container.append($(htmlElementStr));
    }
}

function initProjectDialog(title, disabled, active, hideforkrepo) {
    $('#listOfTags').tagsinput('removeAll');
    $("#listOfTagsLib").tagsinput('removeAll');
    $("#listOfKeywordsLib").tagsinput('removeAll');
    $('#listOfTagsFork').tagsinput('removeAll');
    $(".bootstrap-tagsinput .tag").each(function(index, value) {
        $(value).remove();
    })
    $("#viperProjectModalPopUp input").val("");
    $("#viperProjectModalPopUp textarea").val("");
    $("#viperProjectModalPopUpTitle").text(title);
    $("#repositoryContainer").empty();
    $("#importForkProjectsTabs").tabs();
    if (disabled) {
        $("#importForkProjectsTabs").tabs({
            disabled: disabled,
            active: active
        });
    }
    else {
        // $("#importForkProjectsTabs").tabs("enable");
        $("#importForkProjectsTabs").tabs({
            active: 0,
            activate: function(event,ui) {
                if (ui.newTab.context.innerText == "Library") {
                    updateNamespaceSelect(1);
                }
            }
        });
    }
    if (hideforkrepo) {
        $("#repositorySection").collapse("hide")
    } else {
        $("#repositorySection").collapse("show")
    }
}

function hideAndClearErrorDialgMessages() {
    $(".errorMessage").text("");
    $(".errorMessage").hide()
}

function writeErrorInModal(dialog, text) {
    var ele = dialog.find(".errorMessage");
    ele.text(text);
    ele.show();
}

function initFileDialog(dialogModePar) {
    $("#fileName").val("");
    $("#viperFileModalPopUp .hideWithRename").show();
    $("#importCreateFileTabs").tabs({
        active: 0,
        activate: function(event, ui) {
            var tabActive = $("#importCreateFileTabs").tabs('option', 'active');
            if (tabActive == 0) {
                $("#saveCreateFileButton").text("Create");
                $("#saveCreateFileButton").unbind('click').bind('click', Project.createNewFile);
            } else if (tabActive == 1) {
                $("#saveCreateFileButton").text("Upload");
                $("#saveCreateFileButton").unbind('click').bind('click', kfileDrop.upload);
            } else if (tabActive == 2) {
                $("#saveCreateFileButton").text("Import");
                $("#saveCreateFileButton").unbind('click').bind('click', Project.importFile);
            }
        }
    });
    $("#importCreateFileTabs").tabs("refresh");
    if (dialogModePar == dialogMode.createNewFile) {
        $("#viperFileModalPopUpTitle").text("Add File");
        $("#saveCreateFileButton").unbind('click').bind('click', Project.createNewFile);
        kfileDrop.restartFiles();
        kfileDrop.init();
    } else if (dialogModePar == dialogMode.renameNewFile) {
        $("#viperFileModalPopUp .hideWithRename").hide();
        $("#saveCreateFileButton").text("Rename");
        $("#saveCreateFileButton").unbind('click').bind('click', kfileDrop.upload);
    }
    $("#errorMessageCreateNewFile").text("");
    $("#errorMessageCreateNewFile").hide();
    /*
    $("#fileName").change(function() {
        var filename = $("#fileName").val();
        if (filename != "") {
            var extension = $('input[name=inlineRadioOptions]:checked', '#createNewFileForm').val();
            if (filename.indexOf(".") == -1)
                filename += "." + extension;
            else
                filename = filename.substr(0, filename.lastIndexOf('.')) + "." + extension;
        }
        $("#fileName").val(filename)
    })*/
}


function updateNamespaceSelect(i) {
    if(appData.status.logged) {
        if (i==1) {
            $("#createNamespaceButton").show();
        }
        ViperIDEClient.namespace_cmd('list',null, function(msg) {
            if (msg.data == "ko") {
                console.log("ERROR");
                console.log(msg.msg);
                $('#newLibErrorMessage').show();
                $('#newLibErrorMessage').text(msg.msg);
            }
            else {
                namespaces = msg.data;
                np_select = $("#userNamespace-"+i);
                np_select.find('option').remove().end();
                if (i==1) {
                    np_select.append("<option value='local' selected=''>local</option>");
                }
                $.each(namespaces, function(key, np) {
                    if (np.validated == 1) {
                        np_select.append($("<option></option>").attr("value",np.namespace).text(np.namespace));
                    }
                });
            }
        });
    }
    else {
        $("#createNamespaceButton").hide();
        $("#userNamespace-1").find('option').remove().end().append("<option value='local' selected=''>local</option>");
    }
}

function updateToggleTestingReleaseButton() {
    $('#toggleTestingRelease span').eq(0).removeClass();
    if (appData.currentProject.mode == 'testing') {
        $('#toggleTestingRelease span').eq(0).addClass('fa fa-bank tooltip-br');
        $('#toggleTestingRelease span').eq(1).html('Pass to Release');
    }
    else {
        $('#toggleTestingRelease span').eq(0).addClass('fa fa-flask tooltip-br');
        $('#toggleTestingRelease span').eq(1).html('Pass to Testing');
    }
}
