var publishCurrentStep;
var publishSteps = 4;
var publisRetrievedVersion;
var publishFailedDep;

function showStep(direction) {
	$("#publishLib-step-" + publishCurrentStep).hide();
	publishCurrentStep += direction;
	$("#publishLib-step-" + publishCurrentStep).show();
}

function publishNextStep() {
	showStep(+1);
	if (publishCurrentStep == 2) {
		$("#prevStepButton").show();
	}
	if (publishCurrentStep == 2 && publishFailedDep) {
		$("#nextStepButton").hide();
	}
	if (publishCurrentStep == publishSteps) {
		$("#nextStepButton").hide();
		$("#publishLibButton").show();
	}
}

// function vrsGtRetrieved(version) {
// 	rtv = $.map(publishRetrievedVersion.split("."), function(m) { return parseInt(m); });
// 	vrs = $.map(version.split("."), function(m) { return parseInt(m); });
// 	if (vrs.length != 3) {
// 		return false;
// 	}
// 	if (vrs[0] > rtv[0]) {
// 		return true;
// 	}
// 	if (vrs[0] == rtv[0]) {
// 		if (vrs[1] > rtv[1]) {
// 			return true;
// 		}
// 		if (vrs[1] == rtv[1]) {
// 			if (vrs[2] > rtv[2]) {
// 				return true;
// 			}
// 		}
// 	}
// 	return false;
// }

function publishPrevStep() {
	showStep(-1);
	if (publishCurrentStep == 1) {
		$("#prevStepButton").hide();
	}
	if (publishCurrentStep == (publishSteps - 1)) {
		$("#nextStepButton").show();
		$("#publishLibButton").hide();
	}
}

var Library = {
	publish: function() {
		IDE.modal($("#viperPublishLibModalPopUp"));
		$("#viperPublishLibModalPopUpTitle").text("Publish " + appData.currentProject.name + " - " + appData.currentProject.mode.toUpperCase());
		if (appData.currentProject.mode == 'release') {
			$("#publishLibButton").removeClass();
			$("#publishLibButton").addClass('btn btn-success');
			$("#publishLibButton").html('Publish - Release');
		}
		else {
			$("#publishLibButton").removeClass();
			$("#publishLibButton").addClass('btn btn-danger');
			$("#publishLibButton").html('Publish - Testing');
		}
		publishCurrentStep = 1;
		$("#nextStepButton").show();
		$("#prevStepButton").hide();
		$("#publishLibButton").hide();
		$("#localNamespace").hide();
		$("#publishLib-step-1").show();
		for (var i = 2; i <= publishSteps; i++) {
			$("#publishLib-step-" + i).hide();
		}

		$("#projectsCheckboxContainer").empty();
		for (var i = 0; i < appData.projects.length; i++) {
			var project = appData.projects[i];
			if (!('namespace' in project)) {
				var htmlStr = $('<div class="checkbox"><label><input type="checkbox" name="exampleProject" value="' + project.id + '" class="">' + project.name + '</label></div>');
				$("#projectsCheckboxContainer").append(htmlStr);
			}
		}

		if (appData.currentProject.local == true) {
			$("#localNamespace").show();
			$("#publishLib-step-1").hide();
			$("#prevStepButton").hide();
			updateNamespaceSelect(2);
			$("#createNamespaceButton-2").unbind("click").click(function() {
	            $("#newNamespaceField-2").show();
	            $(this).prop("disabled", true);
	            $(this).addClass('disabled');
	        });
			$("#checkNamespaceButton-2").unbind("click").click(function() {
	            var namespaceName = $("#newNamespaceName-2").val();
	            ViperIDEClient.namespace_cmd('create', namespaceName, function(msg) {
	                $("#newNamespaceField-2").hide();
	                $("#newNamespaceName-2").val("");
	                $("#createNamespaceButton-2").removeClass('disabled');
	                $("#createNamespaceButton-2").prop("disabled", false);
	                if (msg.data == "ok") {
	                    updateNamespaceSelect(1);
	                } else {
	                    console.log("ERROR")
	                    console.log(msg.msg)
						writeErrorInModal($('#viperPublishLibModalPopUp'), msg.msg);
	                }
	            });
	        });
			$("#nextStepButton").html('Change Namespace');
			$("#nextStepButton").unbind('click').click(function() {
				var userNamespace = $("#userNamespace-2").val();
				ViperIDEClient.change_lib_namespace(appData.currentProject.id, userNamespace, function(msg) {
	                if (msg.data == "ok") {
						$("#localNamespace").hide();
						$("#publishLib-step-1").show();
						$("#nextStepButton").unbind('click').click(publishNextStep);
	                    $("#nextStepButton").html('Next');
	                } else {
	                    console.log("ERROR")
	                    console.log(msg.msg)
						writeErrorInModal($('#viperPublishLibModalPopUp'), msg.msg);
	                }
				})
			});
		}
		else {
			$("#nextStepButton").unbind('click').click(publishNextStep);
		}

		$("#dependenciesContainer").empty();
		$("#failedDependenciesContainer").empty();
		ViperIDEClient.get_dependencies(appData.currentProject.id, function(msg) {
			if (msg.data == "ko") {
				writeErrorInModal($('#viperPublishLibModalPopUp'), msg.msg);
			}
			else {
				$.each(msg.data.ok, function(pkg_name, version) {
					var htmlStr = $('<div class="checkbox"><label><input type="checkbox" name="libDependency" value="' + pkg_name + ';'+ version + '" class="" checked disabled> ' + pkg_name + ' ' + Vpm.vlabel(version) + '</label></div>');
					$("#dependenciesContainer").append(htmlStr);
				});
				if (msg.data.fail.length != 0) {
					publishFailedDep = true;
					$("#failedDependenciesContainer").show();
					$.each(msg.data.fail, function(i, import_name) {
						var htmlStr = $('<div>You must publish package resolving this import first: <span class="fa fa-exclamation-circle"></span>' + import_name + '</div>');
						$("#failedDependenciesContainer").append(htmlStr);
					});
				}
				else {
					$("#failedDependenciesContainer").hide();
					publishFailedDep = false;
				}
			}
		});

		$("#currentLibVersion").empty();
		$("#newLibVersion").empty();
		ViperIDEClient.get_my_pkg_version(appData.currentProject.id, function(msg) {
			var tr = appData.currentProject.mode[0];
			if (msg.data == "ko") {
				$("#currentLibVersion").html('<b>First release!</b>');
				var htmlStr = '<div class="checkbox" style="text-align: center;"><label><input type="checkbox" name="libVersion" value="0.1.0"> '+Vpm.vlabel(tr+'0.1.0')+'</label></div>';
				htmlStr +=    '<div class="checkbox" style="text-align: center;"><label><input type="checkbox" name="libVersion" value="1.0.0"> '+Vpm.vlabel(tr+'1.0.0')+'</label></div>';
				htmlStr = $(htmlStr);
				$("#newLibVersion").append(htmlStr);
			}
			else {
				publishRetrievedVersion = msg.data['version'].slice(1);
				$("#currentLibVersion").html('Current package version: '+ Vpm.vlabel(msg.data['version']));
				sVrs = publishRetrievedVersion.split('.');
				var nbc,bc,bf;
				var x=parseInt(sVrs[0])
				var y=parseInt(sVrs[1])
				var z=parseInt(sVrs[2])
				if (x==0){
					nbc = '0.'+(y+1)+'.0'
					bc = '0.'+y+'.'+(z+1)
					bf = '0.'+y+'.'+(z+1)
				} else {
					nbc=x+'.0.0';
					bc = x+'.'+(y+1)+'.0'
					bf = x+'.'+y+'.'+(z+1)
				}
				var htmlStr = '<label class="col-sm-6 control-label">Bugfix: </label>';
				htmlStr += '<div class="checkbox col-sm-6"><label><input type="checkbox" name="libVersion" value="'+bf+'" checked> '+Vpm.vlabel(tr+bf)+'</label></div>';
				htmlStr += '<label class="col-sm-6 control-label">Backward Compatible: </label>';
				htmlStr += '<div class="checkbox col-sm-6"><label><input type="checkbox" name="libVersion" value="'+bc+'"> '+Vpm.vlabel(tr+bc)+'</label></div>';
				htmlStr += '<label class="col-sm-6 control-label">Non Backward Compatible: </label>';
				htmlStr += '<div class="checkbox col-sm-6"><label><input type="checkbox" name="libVersion" value="'+nbc+'"> '+Vpm.vlabel(tr+nbc)+'</label></div>';
				htmlStr = $(htmlStr);
				$("#newLibVersion").append(htmlStr);
			}
			$("#newLibVersion input:checkbox").on('click', function() {
			  var box = $(this);
			  if (box.is(":checked")) {
			    var group = "input:checkbox[name='" + box.attr("name") + "']";
			    $(group).prop("checked", false);
			    box.prop("checked", true);
			  } else {
			    box.prop("checked", false);
			  }
			});
		});

		$("#githubRepoName").val('');
		$("#versionChangelog").val('');

		$("#prevStepButton").unbind('click').click(publishPrevStep);
		$("#publishLibButton").unbind('click').click(function() {
			var ghUser = $("#githubUsername").val();
			var ghPsw  = $("#githubPassword").val();
			var ghRepo = $("#githubRepoName").val();
			var version = $("input[name='libVersion']:checked")[0].value;
			var changelog = $("#versionChangelog").val();
			var examples  = [];
			$("input[name='exampleProject']:checked").each(function() {
				examples.push(this.value);
			});
			var dependencies = {};
			$("input[name='libDependency']:checked").each(function() {
				dependencies[this.value.split(";")[0]] = this.value.split(";")[1];
			});

			var projectID = appData.currentProject.id;
			if (ghUser != "" && ghPsw != "" && changelog != "") {
				ViperIDEClient.publish_library(projectID, ghUser, ghPsw, ghRepo, version, changelog, dependencies, examples, function(msg) {
					if (msg.data == "ok") {
						$('#viperPublishLibModalPopUp').modal('hide');
						IDE.alert("Successfully published!", "viperinfo");
					} else {
						writeErrorInModal($('#viperPublishLibModalPopUp'), msg.msg);
					}
				});
			}
			else {
				writeErrorInModal($('#viperPublishLibModalPopUp'), "Please fill all fields!");
			}
		});
	},
	compileDocs: function() {
		if (appData.currentProject) {
			ViperIDEClient.compile_docs(appData.currentProject.id, function(msg) {
				IDE.alert("Docs updated!", "viperinfo");
				$('#viewDocs').show();
			});
		}
	},
	toggleTestingRelease: function() {
		if (appData.currentProject) {
			ViperIDEClient.toggle_lib_rt(appData.currentProject.id, function(msg) {
				if (appData.currentProject.mode == "testing")
					appData.currentProject.mode = "release";
				else
					appData.currentProject.mode = "testing";
				updateToggleTestingReleaseButton();
				IDE.alert("Toggled to " + appData.currentProject.mode + "!", "viperinfo");
				Project.init()
			});
		}
	}
}
