
from ide.viperthreads import ViperThread

import os
import os.path
import sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.QtWebKit import *

CURRENT_DIR = os.path.dirname(__file__)
aa, bb = os.path.split(os.path.abspath(CURRENT_DIR))
sys.path = [sys.path[0]]+[CURRENT_DIR]+sys.path[1:]


import ide.viper

import tools.tools
import tools.viperlogger

logger = tools.viperlogger.logger(__name__,"ide")



class ViperBrowser(ViperThread):
    def __init__(self,url):
        super().__init__()
        self.url = url

    def start(self):
        self._start(self.run,"Viper Browser")

    def run(self):
        self.app = QApplication(sys.argv)

        web = QWebView()
        web.settings().setAttribute(QWebSettings.JavascriptEnabled, True)
        web.load(QUrl(self.url))
        web.show()

        return self.app.exec_()
