var Vpm = {
	result: [],
	query: "",
	pinfo: {},
	pinfoid:0,
	idx:{
		repo:0,
		pkglist:[],
		most_rated: [],
		most_downloaded: [],
		most_recent: []
	},
	tab: 0,
	synched: null,
	minitab:0,
	i_modules: [],
	search_installed: false,
	search_done: false,
	init: function(){
		$("#vpmSearchList").empty()
		if (!Vpm.search_installed)
			$("#vpmfilter6").hide()
		//$("#vpmsearchheader").hide()
		$('#vpmsearchheader input:radio[name="options"]').change(function(){
			Vpm.redraw_search(this.value)
		})
	},
	display: function(){
		$("#vpmupdateall").hide()
		var list = $("#vpmSearchList")
		var result = []
		var added = 0
		var regex = new RegExp(Vpm.filterby,"i")
		list.empty()
		{
			Vpm.justnew = false
			Vpm.only_installed=false

			if(Vpm.minitab==0) {
				//search
				result = Vpm.result
				Vpm.filterby=""
				Vpm.only_installed=Vpm.search_installed
				$("#vpmsearchtitle").html("Search packages");
			} else if(Vpm.minitab==1) {
				//most rated
				$("#vpmsearchtitle").html("Most Popular");
				result =Vpm.idx.most_rated
			} else if (Vpm.minitab==2) {
				//most downloaded
				$("#vpmsearchtitle").html("Most Downloaded");
				result= Vpm.idx.most_downloaded
			}else if (Vpm.minitab==3) {
				//most recent
				$("#vpmsearchtitle").html("Most Recent");
				result= Vpm.idx.most_recent
			}else if (Vpm.minitab==4) {
				//installed
				$("#vpmsearchtitle").html("Installed");
				result= Vpm.idx.pkglist
				Vpm.justnew = false
				Vpm.only_installed=true
			}else if (Vpm.minitab==5) {
				//updated
				$("#vpmsearchtitle").html('Updates<a href="javascript:Vpm.update_all()"><span class="fa fa-update_icon tooltip-br" id="vpmupdateallbtn" title="Update All Packages"></span></a>');
				result= Vpm.idx.pkglist
				Vpm.justnew = true
				Vpm.only_installed=true
			}
		}

		//console.log("DISPLAYING "+Vpm.justnew+" "+Vpm.only_installed+" "+Vpm.filterby)
		for(var i=0;i<result.length;i++){
			var pack = result[i]

			if((Vpm.only_installed && !pack.installed) || (!Vpm.only_installed && pack.installed )){
				continue
			}

			if (!Vpm.curtypes[Vpm.alltypes.indexOf(pack.type)])
				continue
			if (Vpm.justnew) {
				if(pack.installed && pack.installed==pack.last_version)
					continue
				if(!pack.installed)
					continue
			}

			if (Vpm.testing) {
				if (pack.version[0]=="r")
					continue
			} else {
				if (pack.version[0]=="t")
					continue
			}

			if(Vpm.filterby!=""){
				if (!pack.description.match(regex) && !pack.name.match(regex) && !pack.keywords.join(" ").match(regex))
					continue
			}

			var html="<li class=\"list-group-item vpmsearch_result\">"
			html+="<p class=\"vpmsearch_name\">"+Vpm.vlabel(pack.version)+((pack.installed) ? Vpm.vlabel("<span class=\"fa fa-install tooltip-br\" title=\"installed\"></span>","vpmversion_installed"):"")+((pack.installed && pack.installed!=pack.last_version) ? (Vpm.vlabel("<span class=\"fa fa-new tooltip-br\" title=\"has updates\"></span>","vpmversion_new")):(""))+pack.name+"</p>"
			html+="<p class=\"vpmsearch_desc\">"+pack.description.substring(0,256)+"</p>"
			html+="<p class=\"vpmsearch_fullname\">"+pack.fullname+"</p>"
			html+="<p class=\"vpmsearch_author\">Author: "+pack.author+"</p>"
			if (pack.type=="lib"){
				var istr = ""
				if (pack.version[0]=="t")
					istr+="testing."
				if (pack.tag!="official" || pack.version[0]=="t")
					istr+=pack.tag+"."
				if (pack.namespace!="viper" || pack.version[0]=="t")
					istr+=pack.namespace+"."
				istr+=pack.path
				html+="<p class=\"vpmsearch_import\"><span class=\"fa fa-Python_logo\"></span>from "+istr+" import ...</p>"
			}

			html+="<p><span class=\"label label-default vpmlabel vpmtype\">"+pack.type+"</span><span class=\"label label-default vpmlabel vpmtag\">"+pack.tag+"</span>"
			if (pack.keywords.length>0)
				for(var k=0;k<pack.keywords.length;k++)
					html+="<span class=\"label label-default vpmlabel vpmkeyword\">"+pack.keywords[k]+"</span>"
			html+="</p>"
			html+="<div class=\"btn-group btn-group-xs\" role=\"group\">"
			if (pack.installed && pack.installed!=pack.last_version) {
				html+=Vpm.button("<span class=\"fa fa-check-circle\"></span>","Vpm.install('"+pack.uid+"','"+pack.last_version+"')",null,"Update")
			} else if (pack.installed && pack.installed==pack.last_version) {
			} else if (!pack.installed) {
				html+=Vpm.button("<span class=\"fa fa-plus-circle\"></span>","Vpm.install('"+pack.uid+"','"+pack.last_version+"')",null,"Install")
			}
			if (pack.installed){
				html+=Vpm.button("<span class=\"fa fa-trash-o\"></span>","Vpm.uninstall('"+pack.uid+"','"+pack.installed+"')",null,"Uninstall")
				if (pack.type=="lib"){
					if (pack.enabled){
						html+=Vpm.button("<span class=\"fa fa-toggle-on\"></span>","Vpm.disable('"+pack.uid+"','"+pack.installed+"')",null,"Disable")
					} else {
						html+=Vpm.button("<span class=\"fa fa-toggle-off\"></span>","Vpm.enable('"+pack.uid+"','"+pack.installed+"')",null,"Enable")
					}
				}
			}
			html+=Vpm.button("<span class=\"fa fa-info-circle\"></span>","Vpm.info('"+pack.uid+"','"+pack.version+"')",null,"Info");
			if (pack.version[0]=="r" && pack.type=="lib"){
				if (pack.installed){
					html+='<span class="vpmratingbox"><input type="number" '+((pack.installed) ? ('rateable="1"'):('rateable="0"'))+' value="'+Math.trunc(pack.rating)+'" name="'+pack.uid+'" class="vpmrating" data-clearable="" data-icon-lib="fa" data-active-icon="fa-star" data-inactive-icon="fa-star_outline"/>'
				} else {
					html+='<span class="vpmratingbox">'
					for(var l=0;l<5;l++)
						if (l<Math.trunc(pack.rating))
							html+='<i class="fa fa-star"></i>'
						else
							html+='<i class="fa fa-star_outline"></i>'
				}
				html+='&nbsp;'+(Math.round(pack.rating*10)/10)+'&nbsp;<div class="vpmratinginfo"><span class="fa fa-star" title="ratings">&nbsp;'+pack.rating_count+'</span>|&nbsp;<span class="fa fa-cloud_download" title="downloads">&nbsp;'+pack.downloads+'</span></div></span>'
			}
			html+="</div>"
			html+="</li>"
			list.append(html)
			added+=1
		}
		console.log("Added "+added+" minitab "+Vpm.minitab+" "+Vpm.search_installed+" "+result.length)
		if(added==0){
			if (result.length>0){
				list.append('<p class="text-center" style="font-style:italic">Some results not displayed ('+result.length+').<br>Try to change filters with <span class="fa fa-cog"><span></p>');
			} else if (Vpm.search_done) {
				list.append('<p class="text-center" style="font-style:italic">No results</p>');
			}
		}
		if (added>0 && Vpm.minitab==5){
				$("#vpmupdateall").show()
		} else {
				$("#vpmupdateall").hide()
		}
		//$("input.vpmrating").rating()
		$('input.vpmrating[type=number]').each(function() {
			var val = $(this).val()
      		$(this).rating("initValue");
      		$(this).data('oldVal',val)
      		//$(this).val(val)
    	});

		$("input.vpmrating").change(function(){
			var $this = $(this)
			var name = $this.attr("name")
			var val = $this.val()
			var rateable = $this.attr("rateable")
			if (rateable==1 && val>0){
				ViperIDEClient.vpm_cmd("rate",name,val,function(msg){
					if (msg.data=="ok"){
						IDE.alert("Thanks for your rating!","viperinfo")
					} else {
						IDE.alert(msg.msg,"vipererror")
					}
				})
			}
			$this.val($this.data('oldVal'))
		})
		
	},
	button: function(text,fn,cls,title){
		if (!cls) cls="default"
		if (!title){
			title=""
		} else cls+=" tooltip-bl"
		return "<button type=\"button\" class=\"btn btn-"+cls+"\" onclick=\""+fn+"\" title=\""+title+"\">"+text+"</button>"
	},
	vlabel: function(text,is_version){
		var labelcls=""
		if (!is_version){
			if (text[0]=="t")
				labelcls="vpmversion_test"
			else
				labelcls="vpmversion_release"
		} else
			labelcls=is_version
		return '<span class="label label-primary '+labelcls+'">'+text+'</span>'
	},
	install_shown: function(){
		Vpm.install(Vpm.pinfo.uid,Vpm.pinfo.versions[Vpm.pinfoid][0])
	},
	install: function(uid,version){
		ViperIDEClient.vpm_cmd("install_info",uid,version,function(msg){
			if (msg.data.hasOwnProperty("result")){
				var res = msg.data.result
				var pkg = res.package
				var ilist = res.ilist
				var ulist = res.ulist
				var xlist = res.xlist
				var has_core = res.has_core
				IDE.modal($("#vpminstall_view"))
				$('#vpminstall_button').unbind('click').click(function(){
					ViperIDEClient.vpm_cmd("install",uid,version,function(msg){
						if(msg.data=="ok"){
							IDE.alert("Package Installed")
							$("#vpminstall_view").modal('hide')
							if (has_core){
								IDE.dialog("Restart needed","Viper IDE is going to restart to finish the installation of core packages...")
								Projects.saveCurrent(true)
								setTimeout(function(){IDE.restart()},2000)
							} else {
								ViperIDEClient.refresh(function(){})
								Vpm.result=[]
								Vpm.display()
							}
						} else {
							IDE.alert("Error: "+msg.msg)
						}
					})
				})
				$('#vpminstall_name').html(pkg.name)
				$('#vpminstall_fullname').html(pkg.fullname)
				$('#vpminstall_description').html(pkg.description)
				var html=""
				var whatsnew=""
				for(var i=0;i<pkg.versions.length;i++){
					var thisv = ""
					if (pkg.versions[i][0]==version){
						whatsnew = pkg.versions[i][1]
						thisv="<span class=\"fa fa-hand-o-right\"></span>"
					}
					html+='<li class="list-group-item"><a href="javascript:Vpm.install(\''+pkg.uid+'\',\''+pkg.versions[i][0]+'\')">'+thisv+Vpm.vlabel(pkg.versions[i][0])+'</a></li>'
				}
				$("#vpminstall_version_numbers").html(html)
				html=""
				for(var i=0;i<pkg.versions.length;i++){
					if (pkg.versions[i][0]==version){
						whatsnew = pkg.versions[i][1]
						break
					}
				}
				if (whatsnew.length>0)
					html+="<b>What's new:</b><br><p>"+whatsnew+"</p>"
				if(ilist.length>0 || ulist.length>0 || xlist.length>0)
					html+= '<ul class="list-group">'
				if (ilist.length>0){
					html+='<li class="list-group-item"><p>The following packages are going to be installed:<p>'
					for(var i=0;i<ilist.length;i++){
						var fullname = ilist[i][0]
						var vrs = ilist[i][1]
						html+='<p>'+Vpm.vlabel(vrs)+' - '+fullname+'</p>'
					}
					html+='</li>'
				}
				if (ulist.length>0){
					html+='<li class="list-group-item"><p>The following packages are going to be updated:<p>'
					for(var i=0;i<ulist.length;i++){
						var fullname = ulist[i][0]
						var vrs = ulist[i][1]
						var ivrs = ulist[i][2]
						html+='<p>'+Vpm.vlabel(ivrs)+'<span class="fa fa-hand-o-right"></span>'+Vpm.vlabel(vrs)+' - '+fullname+'</p>'
					}
					html+='</li>'
				}
				if (xlist.length>0){
					html+='<li class="list-group-item"><p>The following packages are going to be removed due to conflicts!<p>'
					for(var i=0;i<xlist.length;i++){
						var fullname = xlist[i][0]
						var vrs = xlist[i][1]
						var mvrs = xlist[i][2]
						var ivrs = xlist[i][3]
						html+='<p>'+Vpm.vlabel(ivrs)+'- ['+Vpm.vlabel(vrs)+' - '+Vpm.vlabel(mvrs)+'] - '+fullname+'</p>'
					}
					html+='</li>'
				}
				if (ilist.length>0 || ulist.length>0 || xlist.length>0)
					html+= '</ul>'
				if (html.length<=0)
					html="no info"
				$("#vpminstall_version_info").html(html)
				$("#vpminstall_button").text("Install "+version)
			} else {
				IDE.alert("Error: "+msg.msg)
			}
		})
	},
	sync: function(){
		$("#buttonVpmSync").addClass("fa-spin")
		ViperIDEClient.vpm_cmd("sync",null,null,function(msg){
			$("#buttonVpmSync").removeClass("fa-spin")
			if(msg.data=="ok"){
				Vpm.display();
				Vpm.synched=true;
//				IDE.alert("Package List Refreshed","viperinfo")
//				Vpm.search(query)
			} else {
				Vpm.display();
				Vpm.synched=false;
//				IDE.alert("Package Error: "+msg.msg)
			}
		})
	},
	uninstall: function(uid,version){
		ViperIDEClient.vpm_cmd("uninstall_info",uid,version,function(msg){
			if (msg.data.hasOwnProperty("result")){
				var res = msg.data.result
				var pkg = res.package
				var rem = res.rem
				var has_core = res.has_core
				IDE.modal($("#vpmuninstall_view"))
				$('#vpmuninstall_button').unbind('click').click(function(){
					ViperIDEClient.vpm_cmd("uninstall",uid,version,function(msg){
						if(msg.data=="ok"){
							IDE.alert("Package Uninstalled")
							$("#vpmuninstall_view").modal('hide')
							if (has_core){
								IDE.dialog("Restart needed","Viper IDE is going to restart to finish the uninstallation of core packages...")
								Projects.saveCurrent(true)
								setTimeout(function(){IDE.restart()},2000)
							} else {
								ViperIDEClient.refresh(function(){})
								Vpm.result=[]
								Vpm.display()
							}
						} else {
							IDE.alert("Error: "+msg.msg)
						}
					})
				})
				$('#vpmuninstall_name').html(pkg.name)
				$('#vpmuninstall_fullname').html(pkg.fullname)
				$('#vpmuninstall_description').html(pkg.description)
				var html="<b>The following packages will be removed:</b><br>"
				for(var i=0;i<rem.length;i++){
					html+='<li class="list-group-item">'+Vpm.vlabel(rem[i][1])+' - <a href="javascript:Vpm.info(\''+rem[i][0]+'\',\''+rem[i][1]+'\')">'+rem[i][0]+'</a></li>'
				}
				$("#vpmuninstall_packages").html(html)
				$("#vpmuninstall_button").text("Uninstall "+version)
			} else {
				IDE.alert("Error: "+msg.msg)
			}
		})
	},
	enable: function(uid,version){
		ViperIDEClient.vpm_cmd("enable",uid,version,function(msg){
			if(msg.data=="ok"){
				Vpm.display();
			} else {
				IDE.alert("Error: "+msg.msg)
			}
		})
	},
	disable: function(uid,version){
		ViperIDEClient.vpm_cmd("disable",uid,version,function(msg){
			if(msg.data=="ok"){
				Vpm.display();
			} else {
				IDE.alert("Error: "+msg.msg)
			}
		})

	},
	_show_info: function(pinfoid){
		var pkg = Vpm.pinfo
		var vrs = pkg.versions[pinfoid][0]
		var whatsnew = pkg.versions[pinfoid][1]
		var dd ="<ul>"
		var deps = pkg.dependencies[vrs]
		for (var i=0;i<deps.length;i++){
			dd+='<li>'+Vpm.vlabel(deps[i][1])+' - <a href="javascript:Vpm.info(\''+deps[i][0]+'\',\''+deps[i][1]+'\')">'+deps[i][0]+'</a></li>'
		}
		dd+="</ul>"
		dd=((whatsnew.length>0)? ("<b>What's new:</b><br>"+whatsnew):(""))+((dd.length<10 )? "":"<b>Dependencies:<b><br>"+dd)

		$("#vpminfo_version_info").html(dd)
		$("#vpminfo_version_title").html("<b>"+vrs+"</b>")
		$("#vpminfo_view .fa-hand-o-right").hide()
		$("#vpminfo_view #_hand"+pinfoid).show()
		$("#vpminfo_install_button").html("Install "+vrs)
		Vpm.pinfoid=pinfoid

	},
	repolink: function(url){
		if (url.indexOf("github://",0)===0){
			url=url.substring(9)
			flds = url.split("/")
			return '<a href="https://github.com/'+flds[0]+'/'+flds[1]+'" target="_blank">'+url+'</a>'
		}
		return "Viper"
	},
	info: function(uid,version){
		ViperIDEClient.vpm_cmd("info",uid,version,function(msg){
			if (msg.data.hasOwnProperty("package")){
				var pkg = msg.data.package
				Vpm.pinfo=pkg
				IDE.modal($("#vpminfo_view"));
				$("#vpminfo_name").html(pkg.name)
				$("#vpminfo_fullname").html(pkg.fullname)
				$("#vpminfo_author").html("<b>Author:</b> "+pkg.author)
				$("#vpminfo_link").html("<b>Repository:</b> "+Vpm.repolink(pkg.url))
				$("#vpminfo_description").html(pkg.description)
				var html=""
				var shi = 0
				for(var i=0;i<pkg.versions.length;i++){
					if(pkg.versions[i][0]==pkg.installed)
						shi=i
					html+='<li class="list-group-item"><a href="javascript:Vpm._show_info('+i+')"><span id="_hand'+i+'"class="fa fa-hand-o-right" style="display:none"></span>'+Vpm.vlabel(pkg.versions[i][0])+'</a></li>'
				}
				$("#vpminfo_version_numbers").html(html)
				Vpm._show_info(shi)
			} else {
				IDE.alert("Package Error: "+msg.msg)
			}
		})
	},
	search: function(query){
		if (Vpm.minitab==0 && query.length<3){
			IDE.alert("Query too short","vipererror")
			return
		}
		Vpm.search_done=true
		if(Vpm.minitab==0){
			Vpm.filterby=""
			ViperIDEClient.vpm_search(query,function(msg){
				if (msg.data.hasOwnProperty("result")){
					var res = msg.data.result
					Vpm.result = res
					Vpm.query = query
					Vpm.display()
				}
			})
		} else {
			Vpm.filterby=query;
			Vpm.display()
		}
	},
	alltypes: ["lib","board","vm","sys","core","vhal","meta"],
	curtypes: [1,1,1,1,1,1,1],
	testing: false,
	toggleTesting:function(){
		Vpm.testing=!Vpm.testing;
		if (Vpm.testing){
			$("#vpmtoggler").removeClass("fa-toggle-on").addClass("fa-toggle-off").removeClass("vpmtogglerrelease").addClass("vpmtogglertesting")
			$("#plugins4_vpmtree").attr("placeholder", "Search testing packages...").val("").focus().blur();
		} else {
			$("#vpmtoggler").removeClass("fa-toggle-off").addClass("fa-toggle-on").removeClass("vpmtogglertesting").addClass("vpmtogglerrelease")
			$("#plugins4_vpmtree").attr("placeholder", "Search release packages...").val("").focus().blur();
		}
		Vpm.display()
	},
	filter_on: function(x){
		if(x==-1){
			for(var i=0;i<=5;i++)
				Vpm.filter_on(i)
			return
		} else if(x==-2) {
			Vpm.search_installed=!Vpm.search_installed
			if (Vpm.search_installed) $("#vpmfilter6").show()
			else $("#vpmfilter6").hide()
		}
		Vpm.curtypes[x]=!Vpm.curtypes[x]
		if(x==5)
			Vpm.curtypes[x+1]=!Vpm.curtypes[x+1]
		if(Vpm.curtypes[x]){
			$("#vpmfilter"+x).show()
		} else {
			$("#vpmfilter"+x).hide()
		}
		Vpm.display()
	},
	filter: function(){
		Vpm.curtypes=[]
		for (var i=0;i<Vpm.alltypes.length;i++){
			var chk = $('#vpm_f_'+Vpm.alltypes[i])
			console.log(chk)
			if (chk.is(":checked"))
				Vpm.curtypes.push(Vpm.alltypes[i])
		}
		Vpm.display()
	},
	totab: function(x){
		Vpm.tab=x
		if(x==2)
			$("#vpmsearchheader").show()
		else $("#vpmsearchheader").hide()
		Vpm.display()
		console.log("TAB"+x+" "+"#vpmtab"+x)
		$("#vpmtab"+((x+1)%3)).removeClass("active")
		$("#vpmtab"+((x+2)%3)).removeClass("active")
		$("#vpmtab"+x).addClass("active")
		console.log($("#vpmtab"+x))
	},
	redraw_search: function(minitab){
		Vpm.minitab=minitab
		if (Vpm.minitab==0) $("#vpminstalledfilter").show()
		else $("#vpminstalledfilter").hide()
		Vpm.display()
	},
	updateStatus: function(idx){
		Vpm.idx = idx
		Vpm.i_modules = Vpm.idx.i_modules
		Vpm.display()
		var pkglist = Vpm.idx.pkglist
		Vpm.corepkg = false
		Vpm.newpackages = false
		if (Vpm.synched!==null){
		var now = Math.floor(Date.now() / 1000)
			if (idx.repo.official && idx.repo.official<(now-24*60*60)){
				Vpm.sync()
			} else if(idx.repo.testing && idx.repo.testing<(now-24*60*60)){
				Vpm.sync()
			}
		}
		var html=""
		for(var i=0;i<pkglist.length;i++){
			if (pkglist[i].fullname=="core.viper.core" && pkglist[i].installed!=pkglist[i].last_version){
				//There is an update to the core!!
				Vpm.corepkg = pkglist[i]
			} else if (pkglist[i].installed!=pkglist[i].last_version){
				Vpm.newpackages = true
			}
			html+='<li>'+Vpm.vlabel(pkglist[i].installed)+" - "+pkglist[i].fullname+'</li>'
			//console.log(pkglist[i].fullname+" - "+pkglist[i].installed+" - "+pkglist[i].last_version)
		}
		if (Vpm.corepkg)
			$("#doUpdateCore").show()
		else
			$("#doUpdateCore").hide()
		if (Vpm.newpackages){
			$("#vpmSearch").addClass("vpm-highlight")
			$("#vpmsoption6 + span").addClass("vpm-highlight")
		}
		else{
			$("#vpmSearch").removeClass("vpm-highlight")
			$("#vpmsoption6 + span").removeClass("vpm-highlight")
		}
		html = '<b>Installation snapshot</b>:<br><ul style="list-style-type: none;">'+html+'</ul>'
		$("#aboutText").html(html)
	},
	updateCore: function(){
		Vpm.install(Vpm.corepkg.fullname,Vpm.corepkg.last_version)
	},
	update_all: function(){
		bootbox.confirm('Are you sure you want to update all packages?', function(result) {
                if (result) {
                    ViperIDEClient.vpm_cmd("update_all",null,null,function(msg){
						if(msg.data=="ok"){
							Vpm.display();
						} else {
							IDE.alert("Error: "+msg.msg)
						}
					})
                }
            });
	}
}
